import { IComponentInputProps, IComponentsInfoMap, IPackageJson } from '../types/common';
import { IMaterialItem, IWeAppComponentInstance, IWeAppCode } from '@cloudbase/lowcode-generator/lib/weapps-core';
export { getMetaInfoBySourceKey, isArray, isPlainObject, deepDeal, simpleDeepClone, deepDealSchema, getFileNameByUrl, } from '@cloudbase/lowcode-generator/lib/generator/util/common';
export declare type PromiseResult<T> = Promise<[null, T] | [Error, null]>;
export declare function promiseWrapper<T>(p: Promise<T>): PromiseResult<T>;
export declare function getCurrentPackageJson(): {
    name: any;
    version: any;
} | undefined;
export declare function getSelfPackageJson(): IPackageJson | undefined;
export declare function JsonToStringWithVariableName(copyJson: any, options?: {
    EOL?: boolean;
}): string;
export declare function requireUncached(module: any): any;
export declare function removeRequireUncached(path?: string): void;
export declare function getInputProps(componentsMetaMap: IComponentsInfoMap): IComponentInputProps;
export declare function getComponentsInfo(appBuildDir: string, dependencies: IMaterialItem[]): Promise<IComponentsInfoMap>;
export declare function getYyptConfigInfo(extraData: any): Promise<{
    yyptAppKey: any;
    reportUrl: any;
    stopReport: boolean;
}>;
export declare function writeLibCommonRes2file(gItem: IMaterialItem, codeDir: string): Promise<void>;
export declare function readComponentLibMata(libDir: any): {
    version?: string;
    schemaVersion?: string;
    styles?: IMaterialItem['styles'];
    dependencies?: IMaterialItem['dependencies'];
    components: {
        [componentName: string]: {
            name: string;
            meta: Object;
        };
    };
    actions?: {
        [actionName: string]: any;
    };
} | null;
export declare function isOfficialComponentLib(name: any, version: any): boolean;
/**
 * 能否使用 Vite
 * @param mode 当前 mode 模式
 */
export declare function canUseVite(mode: string, devTool: string): boolean;
export declare function deepDealComponentSchemaJson(schema: IWeAppComponentInstance, dealFn: (currentSchema: IWeAppComponentInstance) => void): void;
interface ICompileDirs {
    rootBuildDir: string;
    appBuildDir: string;
    materialsDir: string;
}
export declare function getCompileDirs(appKey?: string): ICompileDirs;
export declare function generateLowcodeImportor(lowcodes?: IWeAppCode[]): {
    state: boolean;
    computed: boolean;
    lifecycle: boolean;
    common: boolean;
    styles: IWeAppCode[];
};
